/*------------------------------------------------------------------*/
/* Ce programme ajoute un enregistrement au fichier liste d'objets  */
/* specifie.                                                        */
/* Parametres : bibliotheque, nom, type, description objet          */
/*              plus attributs et biblio srce                       */
/*              nom, bibliotheque et membre fichier d'objets        */
/*              si nom biblio de la liste=*SAME, utiliser valeurs   */
/*              trouvees dans DTAARA nommee ADDOBJPF de QTEMP       */
/*------------------------------------------------------------------*/
             pgm        parm(&BIBLIO +
                             &OBJET  +
                             &TYPE   +
                             &DESC   +
                             &LIBPF +
                             &OBJPF  +
                             &MBRPF  +
                             &ATTRB  +
                             &FRMLIB)

             dcl        &BIBLIO  *CHAR 10   /* biblio de l'objet */
             dcl        &OBJET   *CHAR 10   /* nom objet         */
             dcl        &TYPE    *CHAR 8    /* type objet        */
             dcl        &ATTRB   *CHAR 10   /* attributs objet   */
             dcl        &DESC    *CHAR 50   /* description objet  */
             dcl        &LIBPF  *CHAR 10   /* biblio liste       */
             dcl        &OBJPF   *CHAR 10
             dcl        &MBRPF   *CHAR 10   /* membre de la liste */
             dcl        &FRMLIB  *CHAR 10   /* biblio source     */

             dcl        &ANLIB   *CHAR 10
             dcl        &CRET    *CHAR 1 VALUE('A')

/* si LIBPF = *SAME, recherche DTAARA QTEMP/ADDOBJPF               */

             if (&LIBPF *EQ '*SAME')  do
               rtvdtaara  dtaara(QTEMP/ADDOBJPF (1 10)) rtnvar(&LIBPF)
               monmsg     msgid(CPF1015) exec(do)
                 chgvar     &LIBPF ' '
                 chgvar     &OBJPF  ' '
               enddo
               rtvdtaara  dtaara(QTEMP/ADDOBJPF (11 10)) rtnvar(&OBJPF)
               monmsg     msgid(CPF1015)
               rtvdtaara  dtaara(QTEMP/ADDOBJPF (21 10)) rtnvar(&MBRPF)
               monmsg     MSGID(CPF1015)
               enddo

 /* controle existence liste d'objets  alimenter              */

             chkobj     obj(&LIBPF/&OBJPF) objtype(*FILE) mbr(&MBRPF)
             monmsg     msgid(CPF9800) exec(do)
                sndpgmmsg msg('Fichier ou mbre ' *CAT &OBJPF *TCAT   +
                ' non trouve dans biblio ' *CAT &LIBPF) +
                msgtype(*COMP)
                return
                enddo
             ovrdbf     file(OBJPF) tofile(&LIBPF/&OBJPF) mbr(&MBRPF)
             call       pgm(UPDOBJPF) parm(&BIBLIO   +
                                            &OBJET   +
                                            &TYPE    +
                                            &DESC    +
                                            &CRET    +
                                            &ATTRB   +
                                            &FRMLIB)
             dltovr     file(OBJPF)

 /* si execution reussie, stocker parametres dans DTAARA de QTEMP    */

             if         (&CRET *NE '1') do
                sndpgmmsg msg('Objet ajoute  '         +
                     *CAT &LIBPF *TCAT '/' *CAT &OBJPF *TCAT +
                    ' membre ' *CAT &MBRPF) msgtype(*COMP)

                chgdtaara  dtaara(QTEMP/ADDOBJPF) value(&LIBPF *CAT +
                    &OBJPF *CAT &MBRPF)
                monmsg     MSGID(CPF1015) exec(crtdtaara +
                          dtaara(QTEMP/ADDOBJPF) type(*CHAR) +
                          LEN(30) value(&LIBPF *CAT &OBJPF *CAT +
                          &MBRPF))
                enddo

             else       sndpgmmsg msg('Objet deja present dans +
                          membre ' *CAT &MBRPF *TCAT ' de ' *CAT +
                          &LIBPF *TCAT '/' *CAT &OBJPF) +
                          msgtype(*COMP)
             endpgm
