/*------------------------------------------------------------------+
 * Suppression d'un objet dans une liste d'objets                   +
 *  seul l'enregistrement correspondant a l'objet est supprime      +
 *  l'objet lui-meme n'est pas concerne.                            +
 *------------------------------------------------------------------*/
             pgm        parm(&LIBPF &OBJPF &MBRPF &LIBOB &OBJET &TYPE)

             dcl        &LIBPF   *CHAR 10  /* biblio de la liste  */
             dcl        &OBJPF   *CHAR 10  /* liste d'objets      */
             dcl        &MBRPF   *CHAR 10  /* membre de la liste  */
             dcl        &LIBOB   *CHAR 10  /* biblio de l'objet   */
             dcl        &OBJET   *CHAR 10  /* nom objet           */
             dcl        &TYPE    *CHAR 8   /* type objet          */
             dcl        var(&CDRET) type(*CHAR) len(1) value('D')
             dcl        &DESC    *CHAR 50  /* texte non utilise   */
             dcl        &ATTRB   *CHAR 10  /* attribut, non util  */
             dcl        &FRMLIB  *CHAR 10  /* biblio srce, non u  */


/* si LIBPF = *SAME, recherche DTAARA QTEMP/ADDOBJPF               */

             if (&LIBPF *EQ '*SAME')  do
               rtvdtaara  dtaara(QTEMP/ADDOBJPF (1 10)) rtnvar(&LIBPF)
               monmsg     msgid(CPF1015) exec(do)
                 chgvar     &LIBPF  ' '
                 chgvar     &OBJPF  ' '
               enddo
               rtvdtaara  dtaara(QTEMP/ADDOBJPF (11 10)) rtnvar(&OBJPF)
               monmsg     msgid(CPF1015)
               rtvdtaara dtaara(QTEMP/ADDOBJPF (21 10)) rtnvar(&MBRPF)
               monmsg     MSGID(CPF1015)
               enddo

             ovrdbf     file(OBJPF) tofile(&LIBPF/&OBJPF) mbr(&MBRPF)

             call       pgm(UPDOBJPF) parm(&LIBOB    +
                                            &OBJET   +
                                            &TYPE    +
                                            &DESC    +
                                            &CDRET   +
                                            &ATTRB   +
                                            &FRMLIB)

             if        (&CDRET *EQ '1') do
                sndpgmmsg  msgid(CPF9898) msgf(QCPFMSG) msgdta('Objet +
                  ou liste non trouve') msgtype(*COMP)
                return
                enddo

             sndpgmmsg  msgid(CPF9898) msgf(QCPFMSG) msgdta('Objet +
                  supprime de la liste') msgtype(*COMP)
             endpgm
