/*-------------------------------------------------------------------+
 * Execution de la commande &CMD sur chacun des objets de la liste   +
 * d'objets &LIB/&FILE membre &MBR. Si &TYPX et/ou &ATTRX precises   +
 * filtrage objets de ce type ou de cet attribut                     +
 * Dans chaque commande substitution BIBLIO, OBJET et *PGM par       +
 * bibliotheque, nom et type de l'objet courant                      +
 *-------------------------------------------------------------------*/
             pgm        PARM(&CMD &FILE &LIB &MBR &TYPX &ATTRX)

             dclf       FILE(*LIBL/OBJPF)
             dcl        &CMD *CHAR 500   /* commande a executer */
             dcl        &FILE *CHAR 10   /* fichier liste d'objets */
             dcl        &LIB  *CHAR 10   /* biblio de la liste     */
             dcl        &MBR  *CHAR 10   /* membre a traiter       */
             dcl        &TYPX *CHAR 8    /* type a traiter         */
             dcl        &ATTRX *CHAR 10  /* attribut a traiter     */
             dcl        &CMDD *CHAR 550
             dcl        &TOSTR *CHAR 10
             dcl        &MSGID *CHAR 7
             dcl        &MSGF   *CHAR 10
             dcl        &MSGDTA *CHAR 100
             dcl        &NBER   *DEC 3 0
             dcl        &EXEC   *DEC 4 0
             dcl        &NBERA  *CHAR 3
             dcl        &EXECA  *CHAR 4
             dcl        &MSGFIN *CHAR 200

             if         (&FILE *NE ' ' *AND &LIB *EQ ' ')       +
                         then(chgvar &LIB '*LIBL')
             if         (&MBR *EQ ' ')                          +
                         then(chgvar &MBR '*first')
             if         (&FILE *NE ' ')                         +
                         then(ovrdbf file(OBJPF)                +
                          tofile(&LIB/&FILE) mbr(&MBR))
BCLE:        rcvf

             monmsg     MSGID(CPF0864) exec(goto cmdlbl(END))

             if        (&TYPX *ne ' ' *and &TYPX *ne &TYPE) goto BCLE
             if        (&ATTRX *ne ' ' *and &ATTRX *ne &ATTRB) +
                        goto BCLE

             chgvar     &CMDD &CMD
             call       RPLSTR (&CMDD 'BIBLIO' &BIBLIO)
             call       RPLSTR (&CMDD 'OBJET' &OBJET)
             chgvar     &TOSTR &TYPE
             call       RPLSTR (&CMDD '*PGM' &TOSTR)
             call       QCMDCHK (&CMDD 550)
             monmsg     CPF0006 exec(goto ERREUR)

             call       QCMDEXC (&CMDD 550)
             monmsg     CPF9999 exec(goto ERREUR1)

             chgvar     &EXEC (&EXEC + 1)
             goto       BCLE

ERREUR:      sndpgmmsg  msgid(CPF9898) msgf(QCPFMSG) msgdta(&CMDD) +
                          topgmq(*EXT)
             chgvar     &NBER (&NBER + 1)
             goto       BCLE

ERREUR1:     chgvar     &NBER (&NBER + 1)
             goto       BCLE

END:         chgvar     &EXECA &EXEC
             chgvar     &NBERA &NBER
             chgvar     var(&MSGFIN) value('Commande executee sur ' +
                          *CAT &EXECA *CAT ' objets, non executee +
                          sur ' *CAT &NBERA)
             sndpgmmsg  msg(&MSGFIN) msgtype(*COMP)
             endpgm
