/* Cre fichier d'objets indiqu ou y ajoute un nouveau membre      */
/* puis y ajoute tous les objets de la bibliothque source fournie  */
/*----------------------------------------------------------------- */
/*   Parms : Nom du fichier liste d'objets                          */
/*           Bibliothque du fichier                                */
/*           Nom du membre  crer ou  ajouter                     */
/*           Nom bibliothque source (peut tre  blanc)            */
/*----------------------------------------------------------------- */
             pgm        parm(&OBJPF &LIB &MBR &LIBS)
             dclf       file(QADSPOBJ)
             dcl    &OBJPF   *CHAR 10 /* NOM FICH OBJETS */
             dcl    &LIB     *CHAR 10 /* BIBLIO DU FICHIER  */
             dcl    &MBR     *CHAR 10 /* MEMBRE A CREER     */
             dcl    &LIBS    *CHAR 10 /* BIBLIO SOURCE POUR AJOUT */
             dcl    &LIBO    *CHAR 10 /* BIBLIO CONTENANT APPLI   */
             dcl    &CRET    *CHAR 1
             dcl    &NBOB    *DEC  5  /* NBRE OBJETS COPIES DS LST */
             dcl    &NBOBA   *CHAR 5

             IF (&MBR *EQ ' ') chgvar &MBR &OBJPF

/* Recherche bibliothque contenant modle OBJPF pour CRTDUPOBJ  */

             rtvobjd    obj(OBJPF) objtype(*FILE) rtnlib(&LIBO)

/* controle existence bibliothque cible                         */

             chkobj     obj(QSYS/&LIB) objtype(*LIB)
             monmsg     msgid(CPF9800) exec(do)
                sndpgmmsg  msg('Bibliothque' *BCAT &LIB *BCAT    +
                  ' non trouve') msgtype(*DIAG)
                return
                enddo

/* si fichier liste absent, le crr par copie fichier modle */

             chkobj     obj(&LIB/&OBJPF) objtype(*FILE)
             monmsg     msgid(CPF9800) exec(do)
                crtdupobj  obj(OBJPF) fromlib(&LIBO) objtype(*FILE) +
                          tolib(&LIB) newobj(&OBJPF)
                enddo

 /* si besoin, ajouter le membre demand au fichier liste    */

                chkobj     obj(&LIB/&OBJPF) objtype(*FILE) mbr(&MBR)
                monmsg     msgid(CPF9800) exec(addpfm +
                        file(&LIB/&OBJPF) mbr(&MBR))

             if (&LIBS *EQ ' ') return


 /* si biblio source, ajouter les objets de cette biblio  la liste */

             dspobjd    obj(&LIBS/*ALL) objtype(*ALL) +
                          detail(*SERVICE) output(*OUTFILE) +
                          outfile(QTEMP/QADSPOBJ)

             ovrdbf     file(QADSPOBJ) tofile(QTEMP/QADSPOBJ)
             ovrdbf     file(OBJPF) tofile(&LIB/&OBJPF) mbr(&MBR) +
                          seqonly(*NO)

READ:        rcvf
             monmsg     msgid(CPF0864) exec(goto cmdlbl(SUIT))
             if (&ODOBTP *EQ '*LIB') goto read
             chgvar     &CRET 'A'
             call       pgm(UPDOBJPF) parm(&ODLBNM  +
                                           &ODOBNM  +
                                           &ODOBTP  +
                                           &ODOBTX  +
                                           &CRET    +
                                           &ODOBAT  +
                                           &LIBS)
             if (&CRET *NE '1') chgvar &NBOB (&NBOB+1)
             goto READ

SUIT:        chgvar &nboba &nbob
             sndpgmmsg  msg(&NBOBA *BCAT 'objets ajouts  la liste +
                          indique') msgtype(*COMP)
             endpgm
